import type { ExecutionResult } from 'graphql';
import type { SomeExecutionResultWithoutErrors } from '../../lib/graphql.js';
import type { SchemaInput } from '../0_functions/requestOrExecute.js';
import type { Input as RequestOrExecuteInput } from '../0_functions/requestOrExecute.js';
import { Schema } from '../1_Schema/__.js';
import type { GlobalRegistry } from '../2_generator/globalRegistry.js';
import type { ApplyInputDefaults, Config, ReturnModeTypeBase, ReturnModeTypeSuccessData } from './Config.js';
import type { DocumentFn } from './document.js';
import type { GetRootTypeMethods } from './RootTypeMethods.js';
type RawInput = Omit<RequestOrExecuteInput, 'schema'>;
export type ClientRaw<_$Config extends Config> = {
    raw: (input: RawInput) => Promise<ExecutionResult>;
    rawOrThrow: (input: RawInput) => Promise<SomeExecutionResultWithoutErrors>;
};
export type Client<$Index extends Schema.Index | null, $Config extends Config> = ClientRaw<$Config> & ($Index extends Schema.Index ? ClientTyped<$Index, $Config> : {});
export type ClientTyped<$Index extends Schema.Index, $Config extends Config> = {
    document: DocumentFn<$Config, $Index>;
} & GetRootTypeMethods<$Config, $Index>;
export type InputRaw = {
    schema: SchemaInput;
    headers?: HeadersInit;
};
export type InputPrefilled<$Schema extends GlobalRegistry.SchemaList> = $Schema extends any ? {
    returnMode?: ReturnModeTypeBase | (GlobalRegistry.HasSchemaErrors<$Schema> extends true ? ReturnModeTypeSuccessData : never);
} & InputRaw : never;
export type CreatePrefilled = <$Name extends GlobalRegistry.SchemaNames>(name: $Name, schemaIndex: Schema.Index) => <$Input extends InputPrefilled<GlobalRegistry.Schemas[$Name]>>(input: $Input) => Client<GlobalRegistry.GetSchemaIndexOrDefault<$Name>, ApplyInputDefaults<{
    returnMode: $Input['returnMode'];
}>>;
export declare const createPrefilled: CreatePrefilled;
export type Input<$Schema extends GlobalRegistry.SchemaList> = {
    /**
     * Used internally.
     *
     * When custom scalars are being used, this runtime schema is used to
     * encode/decode them before/after your application sends/receives them.
     *
     * When using root type field methods, this runtime schema is used to assist how arguments on scalars versus objects
     * are constructed into the sent GraphQL document.
     */
    readonly schemaIndex?: Schema.Index | null;
    /**
     * The schema to use.
     *
     * TODO why don't we infer this from the runtime schemaIndex?
     *
     * @defaultValue 'default'
     */
    name?: $Schema['index']['name'];
} & InputPrefilled<$Schema>;
type Create = <$Input extends Input<GlobalRegistry.SchemaList>>(input: $Input) => Client<$Input['schemaIndex'] extends Schema.Index ? GlobalRegistry.GetSchemaIndexOrDefault<$Input['name']> : null, ApplyInputDefaults<{
    returnMode: $Input['returnMode'];
}>>;
export declare const create: Create;
export {};
//# sourceMappingURL=client.d.ts.map